/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.keti.tas.soft.edu;

import com.keti.tas.soft.AdaptorInfomation;
import com.keti.tas.soft.ByteUtil;
import com.keti.tas.soft.CubeTasClient;
import com.keti.tas.soft.CubeTasServer;
import com.keti.tas.soft.KoreaTimeZone;
import com.keti.tas.soft.MsgReceiveEvent;
import com.keti.tas.soft.MsgReceiveListener;
import com.keti.tas.soft.ThingData;
import com.keti.tas.soft.ThingInformation;
import com.keti.tas.soft.ThingTasConnector;
import com.keti.tas.soft.ThingsManagement;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author ChenNan
 */
public class DataAdapter {

	public static void main(String argString[]) throws IOException, InterruptedException {

		final CubeTasServer cubeServer = new CubeTasServer();
		final ThingTasConnector thingServer = new ThingTasConnector();

		cubeServer.start();
		thingServer.start();

		AdaptorInfomation adaptor = new AdaptorInfomation(cubeServer.getServerPort());
		ThingsManagement manager = new ThingsManagement(adaptor);

		manager.addThing("ledstate", "sensoractor", "This is a control board!");
		manager.addThing("test_Thing", "sensoractor", "This is a who send a test message to &Cube");
		manager.addControlThing("ledcontrol", "sensoractor", "This is a control board!", cubeServer.getServerPort());

		thingServer.addReceiveListener(new MsgReceiveListener() {

			@Override
			public void receiveMsgEvent(MsgReceiveEvent event) {
				String strData = event.getMessage();

				System.out.println(strData);

				ThingData mData = new ThingData();

				try {
					System.out.println("receive data : " + strData);
					ThingInformation thing = ThingsManagement.getThingIDByName("test_Thing");
					if (thing != null && thing.getRegistStatus())
						new CubeTasClient()
								.upload(mData.makeThingDataMsg(thing.getThingName(), "test_Thing", strData));
					
				} catch (IOException ex) {
					Logger.getLogger(DataAdapter.class.getName()).log(Level.SEVERE, null, ex);
				}

			}
		});

		// Add a receive listener to CubeServer
		cubeServer.addReceiveListener(new MsgReceiveListener() {

			@Override
			public void receiveMsgEvent(MsgReceiveEvent event) {
				// Generate control meessage and send it to Thing
				System.out.println(KoreaTimeZone.getDisplayTimeNow() + " => Receive a message {" + event.getMessage()
						+ "} from &CUBE");

				if (event.getMessage().length() > 0) {
					String value[] = event.getMessage().split(",");

					if (value.length == 3) {
						String thingName = value[1];
						String action = value[2];

						BoardCommandParser parser = new BoardCommandParser();
						byte[] comm = parser.makeByteCommand(thingName, action);

						if (comm != null) {

							System.out.println(KoreaTimeZone.getDisplayTimeNow() + " => Send a command {"
									+ ThingTasConnector.byteArrayToHex(comm) + "} to Thing");

							thingServer.sendToThing(comm);

							System.out.println(KoreaTimeZone.getDisplayTimeNow() + " => Send a command {"
									+ new String(comm) + "} to Thing");
						} else {
							System.out.println(KoreaTimeZone.getDisplayTimeNow() + " => Receive a wrong command");
						}
					}
				}
			}
		});
	}
}
